//region Imports
'use strict';

var fs = require('fs');
var path = require('path');
var cwd = require('cwd');
var modifyPackageJson = require('../lib/util/modifyPackageJson');
var replaceFile = require('../lib/util/replaceFile');

var _require = require('child_process');

var spawnSync = _require.spawnSync;

var init = require('init-package-json');
var _ = require('lodash');
var confirm = require('inquirer-confirm');
//endregion

// TODO
// - Use init-package-json.
// - Use promises.

function main() {

  // npm init

  if (!fs.existsSync(cwd('package.json'))) {
    console.log('Initializing npm package...');
    spawnSync('npm init -f');
    //init(cwd(), 'package.json', {}, (e, data) => {
    //})
  }

  // gulp

  console.log('Adding gulp to package.json');

  modifyPackageJson(function (json) {
    _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js');
    return json;
  }, function (e) {
    if (e) throw e;

    // gulpfile.js

    console.log('Updating gulpfile...');

    var gulpfileContents = "var gulp = require('gulp')\n" + "require('babelator')(gulp)\n";
    replaceFile(cwd('gulpfile.js'), gulpfileContents, function () {

      // Add babelator dependency

      console.log('Adding babelator dependency...');

      confirm('Run `npm i -D babelator gulpjs/gulp.git#4.0`?').then(function () {
        spawnSync('npm', ['i', '-D', 'babelator', 'gulpjs/gulp.git#4.0'], { stdio: 'inherit' });
      }, function () {

        // Instructions

        console.log('Please run `npm install`');
        console.log('Tip: Use `npm_lazy` module to locally cache npm modules.');
      });
    });
  });
}

function cli() {
  main();
}

module.exports = cli;