//region Imports
const fs = require('fs')
const path = require('path')
const cwd = require('cwd')
const modifyPackageJson = require('../lib/util/modifyPackageJson')
const replaceFile = require('../lib/util/replaceFile')
const {spawnSync} = require('child_process')
const init = require('init-package-json')
const _ = require('lodash')
const confirm = require('inquirer-confirm')
//endregion

// TODO
// - Use init-package-json.
// - Use promises.

function main() {

  // npm init

  if (!fs.existsSync(cwd('package.json'))) {
    console.log('Initializing npm package...')
    spawnSync('npm init -f')
    //init(cwd(), 'package.json', {}, (e, data) => {
    //})
  }

  // gulp

  console.log('Adding gulp to package.json')

  modifyPackageJson((json) => {
    _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js')
    return json
  }, (e) => {
    if (e) throw e

    // gulpfile.js

    console.log('Updating gulpfile...')

    var gulpfileContents =
      "var gulp = require('gulp')\n" +
      "require('babelator')(gulp)\n"
    replaceFile(cwd('gulpfile.js'), gulpfileContents, () => {

      // Add babelator dependency

      console.log('Adding babelator dependency...')

      confirm('Run `npm i -D babelator gulpjs/gulp.git#4.0`?').then(() => {
        spawnSync('npm', ['i', '-D', 'babelator', 'gulpjs/gulp.git#4.0'], {stdio: 'inherit'})
      }, () => {

        // Instructions

        console.log('Please run `npm install`')
        console.log('Tip: Use `npm_lazy` module to locally cache npm modules.')

      })

    })

  })


}

function cli() {
  main()
}

module.exports = cli
