//region Imports
const path = require('path')
const {join} = path
const conflict = require('gulp-conflict')
const _ = require('lodash')
const cwd = require('cwd')
const modifyPackageJson = require('../util/modifyPackageJson')
const replaceFile = require('../util/replaceFile')
const fs = require('fs')
//endregion

export default (gulp, opts) => {

  _.defaults(opts, {
    destDir: '',
  })

  let desc = 'Bootstraps module by modifying package.json and copying files from `babelator/templates` into module dir.'

  const babelatorContents = "// NOTE: Override `babelator/config` settings from here.\nmodule.exports = {}\n"

  gulp.task('babelator:bootstrap:config', function(done) {
    replaceFile(cwd('babelator.js'), babelatorContents, done)
  })

  gulp.task('babelator:bootstrap:pjson', function(done) {
    modifyPackageJson((json) => {
      _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js')
      return json
    }, done)
  })

  gulp.task('babelator:bootstrap', gulp.series('babelator:bootstrap:config', 'babelator:bootstrap:pjson'))

}
